	device zxspectrum128
        ORG #6000
begin
; jr $
; ld a,99
; cp 24
; jr nc,less

	call blacks
;    ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr

;form stack
	ld hl,ou
	ld a,8
fo0:
	push af
fv1: ld de,buf+14
	ld (hl),$2A:inc hl ;ld hl,(NNNN)
	ld (hl),e:inc hl
	ld (hl),d:inc hl
	dec de,de
	ld (fv1+1),de

fv2: ld de,buf+30
	ld (hl),$ED:inc hl; ld de,(NNNNN)
	ld (hl),$5B:inc hl
	ld (hl),e:inc hl
	ld (hl),d:inc hl
	dec de,de
	ld (fv2+1),de

	ld c,4
fo1:
	ld a, $D5:call put16 ; push de
	ld a, $E5:call put16 ; push hl
	dec c:jr nz,fo1
	pop af
	dec a
	jp nz,fo0
;end routine
	ld (hl),$31:inc hl ; ld sp,NNNN
	ld (ous+2),hl
	inc hl,hl
	ld (hl),$c9:inc hl ; ld sp,NNNN

;	ld hl,$5800,de,$5803,bc,765:set 6,(hl):ldir
;draw text
	ld ix,m1
	call textout
	call textout
	call textout
	call textout

;	jr $
;DEATH
	ld hl,lgo
	ld ix,$5800
	call sprout
;STAR
	ld ix,$5A00
	call sprout
;colors
	ld hl,$5920,a,$46:call aline
	ld hl,$5960,a,$05:call aline
	ld hl,$59A0,a,$47:call aline
	ld hl,$59E0,a,$42:call aline
	
	ld a,$4F,($59b4),a
;song
	ld hl,song:call INIT
;int
	di
	ld hl,$BE00,de,$BE01,bc,256,(hl),$BF:ldir
	ld a,$C3,($BFBF),a
	ld hl,intvec,($BFC0),hl
	ld a,$BE,i,a
	im 2
ilp:
	ei:halt
iv0:ld a,-1
	inc a
	ld (iv0+1),a
	ld ix,$4800
	call stack

iv1:ld a,-1
	dec a
	ld (iv1+1),a
	ld ix,$5800
	call stack
; keyboard
kp:	call keyr1
;Q	
	ld bc,$FBFE
	in a,(c)
	rra
	jp c,key2
	ld ix,m22
	ld de,#4869+8
	call to
	ld a,$C9,(setkey),a
key2:
;C
	ld bc,$FEFE
	in a,(c)
	and 8
	jp nz,key3

	ld ix,m23
	ld de,#4869+8
	call to
	ld a,00,(setkey),a
key3:
	ld bc,$7FFE
	in a,(c)
	rra
	jp c,ilp
;picture
	call blacks
	ld hl,picp,de,$4000
	call dzx7_standard
	xor a
fal: ei:halt:halt:halt:halt
	ld hl,$5800,de,$5801,bc,767,(hl),a:ldir
	add a,8
	cp $40
	jr nz,fal
;stop im 2
	ei:halt:di
	ld a,$3F,i,a
	im 1
;AY !
	ld de,0
sho:
	LD BC ,$FFFD
	OUT (C) , D;reg#
	ld b,$BF;LD            BC ,$BFFD
	out (c),e
	inc d
	bit 4,d
	jr z,sho
;loader
	ld a,$10,bc,$7ffd:out (c),a
;	ld hl,page0b,de,$8000,bc,page0e-page0b:ldir
;	jr $
	ld sp,$7FFF
	ld hl,$8000
	ld de,($5CF4)
	ld bc,#1705
	call $3d13
;	jr $
	call setkey
;set level
	ld a,(m33)
	sub $30
	ld c,a
	add a,a
	add a,a
	add a,c
	add a,a
	ld c,a
	ld a,(m33+1)
	sub $30
	add a,c
	cp 24
	jr nc,nosetlev
	or a:jr z,nosetlev
	ld ($8BA2),a
	ld hl,0,($8544),hl
nosetlev:
	ei
	jp $8000
blacks:
    ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr
    ret
kt1: db "09876"
kt2: db "12345"
keyr2:
	ld bc,$EFFE
	in a,(c)
	cpl
	and 31
	ret nz
	ld bc,$F7FE
	in a,(c)
	cpl
	and 31
	ret nz

	ld hl,keyr1,(kp+1),hl

	ret
keyr1:
	ld bc,$EFFE
	ld hl,kt1
	call ksc
	cp $FF
	jr nz,putv
	ld bc,$F7FE
	ld hl,kt2
	call ksc
	cp $FF:ret z
putv: ld de,0
;	jr $
	ld hl,m33
	add hl,de
	ld (hl),a
;draw cursor
	ld hl,$59b4
	ld (hl),$47:inc hl
	ld (hl),$47:dec hl
	ld a,e
	xor 1
	ld e,a
	ld (putv+1),de
	add hl,de
	ld (hl),$4F

	ld hl,keyr2,(kp+1),hl

	ld ix,m33
	ld de,$48A9+11
	call to
	ret
ksc:
	in a,(c)
	cpl
	and 31
	jr z,nokey;ret z

	ld b,5
klp: rra
	jr nc,knxt
	ld a,(hl):ret
knxt:
	inc hl
	djnz klp
nokey:
	ld a,$FF
	ret
;setup game keys
setkey: ret
;$0B-up,$0A-down,08-left,09-right
	ld a,$0A,($8577),a;A-down
	ld a,$0B,($857B),a;Q-up
	ld a,$09,($857F),a;P-left
	ld a,$08,($8583),a;O-right
	ret
m1:
	dw $4821
	db "'DEATH STAR' RIP BY G0BLINISH",0
m2:
	dw #4869
	db "CONTROL:"
m22:	db " QAOP ",0

m3:
	dw $48A9
	db "START FROM:"
m33:	db "00",0
m4:
	dw $48E3
	db "Q/C-CONTROL,0-9-LVL,SPC-GO",0

m23:	db "CURSOR",0
textout:
	ld e,(ix+0):inc ix
	ld d,(ix+0):inc ix
to:
	ld a,(ix+0):inc ix
	or a:ret z
	ld h,0,l,a,bc,fnt-256
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	ld b,8
	push de
toch:
	ld a,(hl),(de),a
	inc hl,d
	djnz toch
	pop de
	inc e
	jr to
put16:
	ld b,16
pulp: ld (hl),a:inc hl:djnz pulp
	ret
intvec:
	push ix,iy
	push hl,de,bc,af
	exx:exa
	push hl,de,bc,af
	CALL PLAY
	pop af,bc,de,hl
	exx:exa
	pop af,bc,de,hl
	pop iy,ix
	ei:ret

aline:
	ld b,32
al: ld (hl),a
	inc hl
	djnz al
	ret
sprout:
	ld c,4
so0:
	xor a
	rlc (hl)
	jr nc,noput
;	sbc a,a
;	and 7
	ld a,7
noput:
	ld (ix+0),a
	ld (ix+1),a
	ld (ix+32),a
	ld (ix+33),a
	inc ix,ix
	ld a,ixl
	and 15
	jp nz,so0
	inc hl
	ld a,ixl
	and 31
	jp nz,so0
	ld de,32
	add ix,de
	dec c:jr nz,so0
	ret
stack:
	and 15
	ld l,a,h,0
	ld bc,anim
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	ld de,buf
	ld bc,32
	ldir
	jp ous
lgo:incbin "ds_binlgo.bin"
fnt:incbin "crk_2.fnt"
anim: incbin "staranim.bin"
plyr:include "PTxPlay.a80"
song:incbin "nyan.pt3"
picp:incbin "dstar.screen.zx7"
zx7:include "zx7.a80"
buf: ds 32
ous: ld (0),sp
 ld sp,ix
ou:
end

	page 0
	org $C000
 DEFINE pg0
page0b:
 incbin "dstarb.bin"
page0e:
	display /d,end-begin
	display keyr2
	savesna "!void.sna",begin

;-----------------------------------------------------------
;add after
;page0b:
; DEFINE pg0

 macro	sectors datab,datae

	db 1,5,(datae-datab+255)/256
; IF low (datae-datab)=0
;   db 1,5,high (datae-datab)
; ELSE
;   db 1,5,(1+high (datae-datab))
; ENDIF
;
	endm

 MODULE boot
Basic:
 db #00,#01; 
 DW EndLine1 - Line1
Line1:
 db #EA;REM

 ;test 128K
;	ld hl,$FFFF
;	ld bc,$7FFD
;	ld de,$1011
;	out (c),d:ld (hl),d
;	out (c),e:ld (hl),e
;	out (c),d
;	ld a,(hl):cp d:ret nz

 ld sp,#5FFE

    res 4,(iy+1)
    xor a:out ($FE),a
    ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr

;title
;	IFUSED tit_b
; di
; ld de,(#5CF4)
; ld hl, #6000
;; ld a,#10,bc,#7FFD:out (c),a
; sectors tit_b,tit_e
; call #3d13
; call #6000
;	ENDIF

;demo
 di
 ld de,(#5CF4)
 ld hl, #6000
 ld a,#10,bc,#7FFD:out (c),a
 sectors begin,end
 call #3d13

;	IFDEF pg0
; di
; ld de,(#5CF4)
; ld hl, #C000
; sectors page0b,page0e
; call #3d13
;	ENDIF

	IFDEF pg1
 di
 ld de,(#5CF4)
 ld hl, #C000
 ld a,#11,bc,#7FFD:out (c),a
 sectors page1b,page1e
 call #3d13
	ENDIF

	IFDEF pg3
 di
 ld de,(#5CF4)
 ld hl, #C000
 ld a,#13,bc,#7FFD:out (c),a
 sectors page3b,page3e
 call #3d13
	ENDIF

	IFDEF pg4
 di
 ld de,(#5CF4)
 ld hl, #C000
 ld a,#14,bc,#7FFD:out (c),a
 sectors page4b,page4e
 call #3d13
	ENDIF

 ld a,#10,bc,#7ffd:out (c),a
 jp begin


 db "fuckhype"
 db #0D
EndLine1:
 db #00,#02
 DW EndLine2 - Line2
Line2:
 db #20,#FD,#B0
 db #22,#32,#34,#35,#37,#35,#22;clear val "24575"
 db #3A; :
 db #F9,#C0,#28,#35;randomize usr (5+256*peek val "23635"+peek val "23636"
 db #0E,#00,#00,#05,#00,#00,#2B
 db #32,#35,#36
 db #0E,#00,#00,#00,#01,#00,#2A,#BE

 db #B0
 db #22,#32,#33,#36,#33,#36,#22;"23635"
 db #2B;???
 db #BE
 db #B0
 db #22,#32,#33,#36,#33,#35,#22;"23636"
 db #29

;+128K
;	db ":",245 ;:PRINT
;	db 34,17,0,16,7,"128K only",34
 
 db #0D;)
 db #80
 db #AA,1,0;;;;;;;;;;;;;autorun line,change program length to -4, e.g. 83-4=79
EndLine2:
EndBasic:
 ENDMODULE

	display /d,end-begin

    EMPTYTRD "dust.trd" ;create empty TRD image
	SAVETRD "dust.trd", "DStar.B", boot.Basic, boot.EndBasic - boot.Basic

    SAVETRD "dust.trd","demo.C",begin,end-begin

	IFDEF pg0
    PAGE 0
    SAVETRD "dust.trd","pg0.C",page0b,page0e-page0b
	ENDIF

	IFDEF pg1
    PAGE 1
    SAVETRD "dust.trd","pg1.C",page1b,page1e-page1b
	ENDIF

	IFDEF pg3
    PAGE 3
    SAVETRD "dust.trd","pg3.C",page3b,page3e-page3b
	ENDIF

	IFDEF pg4
    PAGE 4
    SAVETRD "dust.trd","pg4.C",page4b,page4e-page4b
	ENDIF

;-----------------------------------------------------------

